import math;
import object;
import common;
import sys;


def collisionDetect( ):
	rockets = common.Global_objMovArray;
	objs = common.Global_objArray;
#	hero = common.Global_Camera.m_vPosition;
	for obj in objs:
	#check collision of camera
	    hero = common.Global_Camera.m_vPosition;
	    if( obj.isInside([hero.x, 10, hero.z]) ):
		#print "Collision with object";
		if obj.type == "flareammo":
		    if common.Global_soundEnabled:
			common.Global_soundList['pick'].play();
		    common.Global_ammoFlare += 25;
		    obj.health = -1;

		elif obj.type == "rocketammo":
		    if common.Global_soundEnabled:
			common.Global_soundList['pick'].play();
		    common.Global_ammoRockets += 10;
		    obj.health = -1;

	    if obj.center[0]*obj.center[0]+obj.center[2]*obj.center[2] >= 1000*1000:
		obj.health = -1;
	#for each flare or rocket
	for i in xrange(len(rockets)):
		#caliculate the next position of the rocket
		newcenter = rockets[i].center;
		newcenter[0]+=rockets[i].velocity[0];
		newcenter[1]+=rockets[i].velocity[1];
		newcenter[2]+=rockets[i].velocity[2];
	    
		#remove the rockets that are in space :)
		if newcenter[0] <= -1500 or newcenter[0] >= 1500 :
		    rockets[i].health = -1;
		if newcenter[2] >= 1500 or newcenter[2] <= -1500 :
		    rockets[i].health = -1;

		#for each object in the world
		for obj in objs:

		    #check collision only if the object is alive
		    if( obj.health > 40 and obj.isInside(newcenter) ):
			if common.Global_soundEnabled :
				if obj.type == "pplant":
				    common.Global_soundList['alarm'].play();
				else:
				    common.Global_soundList['explosion'].play();
			#reduce the health of object
			if rockets[i].type == "rocket":
			    obj.health -= 100;
			elif rockets[i].type == "flare":
			    obj.health -= 50;
			else:
			    obj.health -= 10;
			#destry the rocket
			rockets[i].health = -1;		
			
			#if the object is in air bring it down :)
			#set the obj's velocity
		    	if obj.type == "land":
			    common.Global_scoreCount += 100;
			    if obj.health <= 40:
				obj.velocity = [0, 0, 0];
			#common.Global_EnemyCount -= 1;
			if obj.type == "air":
			    common.Global_scoreCount += 200;
			#common.Global_EnemyCount -= 1;
			    if obj.health <= 40:
				obj.velocity[1] = -6;

		    #check if the object is still in view

	for i in rockets:
		if i.health == -1:
			rockets.remove(i);
	for i in objs:
	    if i.health < 0 and not(i.type=="pplant"):
		objs.remove(i);
