# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'editor.ui'
#
# Created: Tue Aug 30 12:44:38 2005
#      by: The PyQt User Interface Compiler (pyuic) 3.14.1
#
# WARNING! All changes made in this file will be lost!


from qt import *


class Obj:
	def __init__(self, type="tree", center=[0,0,0], velocity=[0, 0, 0]):
		self. center = center;
		self.type= type;
		self.velocity = velocity;

class Map(QFrame):
	def __init__(self, parent, name):
		QFrame.__init__(self, parent, name);
		self.setGeometry(5, 5, 450,450);
		self.parent = parent;
		self.objs = [];
		self.setPaletteBackgroundColor(QColor(255,255,255));

	def mousePressEvent(self, e):
		if ( self.parent.cur == None ):
			return ;
		elif( self.parent.cur == 'air' ):
			tmp = Obj( self.parent.cur, [ e.x()-self.width()/2, 70, (self.height()-e.y())-self.height()/2] );
			self.objs.append(tmp);
		else:
			tmp = Obj( self.parent.cur, [ e.x()-self.width()/2, 0, (self.height()-e.y())-self.height()/2] );
			self.objs.append(tmp);
		self.repaint();
		
		fp = open("mission.map", 'w');
		
		fp.write(len(self.objs).__str__()+"\n");
		for obj in self.objs:
			fp.write(obj.type+" ");
			fp.write(str(obj.center[0]*4)+" "+str(obj.center[1]*2)+" "+str(obj.center[2]*4));
			fp.write(" ");
			fp.write(obj.velocity[0].__str__()+" "+obj.velocity[1].__str__()+" "+obj.velocity[2].__str__());
			fp.write("\n");
		fp.close( );
	
	def paintEvent(self, e):
		ptr = QPainter(self);	
		ptr.setPen(QColor(0,0,0));
		ptr.drawRect( 0, 0, self.width(), self.height() );
		ptr.setPen(QColor(255,0,0));
		ptr.drawLine( 0, self.height()/2, self.width(), self.height()/2 );
		ptr.setPen(QColor(0,0,250));
		ptr.drawLine( self.width()/2, 0, self.width()/2, self.height() );

		for obj in self.objs:
			if obj.type == "tree":
				ptr.setPen(QColor(0,200,0));
			elif obj.type == "pplant":
				ptr.setPen(QColor(5,0,0));
			elif obj.type == "land":
				ptr.setPen(QColor(255,6,8));
			elif obj.type == "air":
				ptr.setPen(QColor(20,0,255));
			ptr.drawEllipse( obj.center[0]+self.width()/2, self.height()-obj.center[2]-self.height()/2, 10, 10 );

class Editor(QWidget):
	def __init__(self,parent = None,name = None,fl = 0):
		QWidget.__init__(self,parent,name,fl)
		self.cur = None;

		if not name:
			self.setName("Editor")

		self.textLabel1 = QLabel(self,"textLabel1")
		self.textLabel1.setGeometry(QRect(12,12,129,16))

		self.frame3 = Map(self,"frame3")
	#	self.frame3.setGeometry(QRect(12,37,470,384))
		self.frame3.setFrameShape(QFrame.StyledPanel)
		self.frame3.setFrameShadow(QFrame.Raised)

		self.buttonGroup1 = QButtonGroup(self,"buttonGroup1")
		self.buttonGroup1.setGeometry(QRect(491,32,119,212))
		self.buttonGroup1.setExclusive(1)

		self.r2 = QRadioButton(self.buttonGroup1,"r2")
		self.r2.setGeometry(QRect(7,57,102,21))

		self.r3 = QRadioButton(self.buttonGroup1,"r3")
		self.r3.setGeometry(QRect(6,84,102,21))

		self.r4 = QRadioButton(self.buttonGroup1,"r4")
		self.r4.setGeometry(QRect(6,111,102,21))

		self.r1 = QRadioButton(self.buttonGroup1,"r1")
		self.r1.setGeometry(QRect(7,30,102,21))

		self.languageChange();	
		self.resize(QSize(618,499).expandedTo(self.minimumSizeHint()))
		self.clearWState(Qt.WState_Polished)

		self.connect(self.r1,SIGNAL("clicked()"),self.treeMode)
		self.connect(self.r2,SIGNAL("clicked()"),self.pplantMode)
		self.connect(self.r3,SIGNAL("clicked()"),self.landMode)
		self.connect(self.r4,SIGNAL("clicked()"),self.airMode)


	def languageChange(self):
		self.setCaption(self.__tr("Form1"))
		self.textLabel1.setText(self.__tr("Click to add item"))
		self.buttonGroup1.setTitle(self.__tr("Objects"))
		self.r2.setText(self.__tr("pplant"))
		self.r3.setText(self.__tr("land"))
		self.r4.setText(self.__tr("air"))
		self.r1.setText(self.__tr("tree"))

	def treeMode(self):
		self.cur = "tree";

	def pplantMode(self):
		self.cur = "pplant";

	def landMode(self):
		self.cur = "land";

	def airMode(self):
		self.cur = "air";

	def __tr(self,s,c = None):
		return qApp.translate("Editor",s,c)
