import common;
import object;
from OpenGL.GL import *;
from OpenGL.GLU import *;
import sys;
import math;
import random

#find the rot angle for a given x, z:
def rot( x, z ):
    theta =math.atan(math.fabs(x/z))*180/math.pi;
    if ( x >= 0 and z >= 0 ):
	return -180 + theta;
    elif( x <0 and z > 0 ):
	return 180-theta;
    elif( x > 0 and z < 0 ):
	return -theta;
    else:
	return theta;

def genAmmo( ):
    center = [ 0, 0, 0];
    velocity = [0,0,0]
    #ammotype = random.choice(['','flareammo', 'rocketammo']) ;
    ammotype = random.choice(['rocketammo']) ;
    if ammotype:
	ammoObj=object.gameObject( center, velocity, ammotype);
	rad=random.randrange(100,500);
	angle=random.randrange(0,360)*math.pi/180;
	ammoObj.center[0]=rad*math.cos(angle);
	ammoObj.center[1] = 0;
	ammoObj.center[2]=rad*math.sin(angle);
	ammoObj.health=40;
	common.Global_objArray.append(ammoObj);

    
def genEnemy():
    radius=900;
    theta=random.randrange(360)*math.pi/180.0
    center = [ radius*math.sin(theta),0,radius*math.cos(theta) ];
    velocity = [0,0,0]
    obj = object.gameObject( center, velocity, random.choice(['land','air']) );
    if obj.type == "land":
#	common.Global_EnemyCount += 1;
#	common.Global_MaxEnemyCount -= 1;
	obj.height = 30; 
	obj.width = 42;
	obj.length = 20;
	m=-math.sqrt(obj.center[0]*obj.center[0]+obj.center[2]*obj.center[2])
	obj.nromal=[]
	obj.velocity[0]=2*obj.center[0]/m;
	obj.velocity[2]=2*obj.center[2]/m;
	obj.rotAngle = rot( obj.center[0], obj.center[2] );
    elif obj.type == "air":
	#common.Global_EnemyCount += 1;
	#common.Global_MaxEnemyCount -= 1;
	obj.center[1] = random.randrange(70,140);
	obj.height = 20; 
	obj.width = 60;
	obj.length = 60;
	m=-math.sqrt(obj.center[0]*obj.center[0]+obj.center[2]*obj.center[2])
	obj.velocity[0]=6*obj.center[0]/m;
	obj.velocity[2]=6*obj.center[2]/m;
	obj.rotAngle = rot( obj.center[0], obj.center[2] );
    common.Global_objArray.append(obj);
	
#for loading the specified map
def loadMap( fname ):
	fp = open(fname);	
	numobjs = int(fp.readline( ));		
	pplant = [ 0, 0, 0 ];
	common.Global_objArray = [];
	common.Global_objMovArray = [];
	common.Global_scoreCount = 0;
#	common.Global_EnemyCount = 0;
#	common.Global_MaxEnemyCount=24;

	for i in xrange(numobjs):
		line = fp.readline( );
		tokens = line.split(); 
		center = [ float(tokens[1]), float(tokens[2]), float(tokens[3]) ];
		velocity = [ float(tokens[4]), float(tokens[5]), float(tokens[6]) ];	
		obj = object.gameObject( center, velocity, tokens[0] );
	#	print obj.type, obj.center;	
		#height = 0;
		#width = 0;
		#length = 0;
		if obj.type == "tree":
			obj.height = 70;
			obj.width = 20;
			obj.length = 20;

		elif obj.type == "pplant":
			#obj.height = 180; 
			obj.height = 70; 
			obj.width = 140;
			obj.length = 100;
			obj.health = 500;

		elif obj.type == "land":
		#	common.Global_EnemyCount += 1;
		#	common.Global_MaxEnemyCount -= 1;
			obj.height = 40; 
			obj.width = 42;
			obj.length = 20;
			m=-math.sqrt(obj.center[0]*obj.center[0]+obj.center[2]*obj.center[2])
			obj.nromal=[]
			obj.velocity[0]=2*obj.center[0]/m;
			obj.velocity[2]=2*obj.center[2]/m;
			obj.rotAngle = rot( obj.center[0], obj.center[2] );
		elif obj.type == "air":
		#	common.Global_EnemyCount += 1;
		#	common.Global_MaxEnemyCount -= 1;
			obj.height = 20; 
			obj.width = 60;
			obj.length = 60;
			m=-math.sqrt(obj.center[0]*obj.center[0]+obj.center[2]*obj.center[2])
			obj.velocity[0]=6*obj.center[0]/m;
			obj.velocity[2]=6*obj.center[2]/m;
			obj.rotAngle = rot( obj.center[0], obj.center[2] );
		common.Global_objArray.append(obj);
	fp.close();
#render the objects that are in the view
#def render( ):
#	for obj in common.Global_objArray
#		if not(obj.isCulled( )):
#			obj.render( );

	
#if __name__=="__main__":
#	loadMap("mission.map");
